/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	v1 "sigs.k8s.io/gateway-api/apis/v1"
)

// GatewayTLSConfigApplyConfiguration represents a declarative configuration of the GatewayTLSConfig type for use
// with apply.
type GatewayTLSConfigApplyConfiguration struct {
	Mode               *v1.TLSModeType                           `json:"mode,omitempty"`
	CertificateRefs    []SecretObjectReferenceApplyConfiguration `json:"certificateRefs,omitempty"`
	FrontendValidation *FrontendTLSValidationApplyConfiguration  `json:"frontendValidation,omitempty"`
	Options            map[v1.AnnotationKey]v1.AnnotationValue   `json:"options,omitempty"`
}

// GatewayTLSConfigApplyConfiguration constructs a declarative configuration of the GatewayTLSConfig type for use with
// apply.
func GatewayTLSConfig() *GatewayTLSConfigApplyConfiguration {
	return &GatewayTLSConfigApplyConfiguration{}
}

// WithMode sets the Mode field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Mode field is set to the value of the last call.
func (b *GatewayTLSConfigApplyConfiguration) WithMode(value v1.TLSModeType) *GatewayTLSConfigApplyConfiguration {
	b.Mode = &value
	return b
}

// WithCertificateRefs adds the given value to the CertificateRefs field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the CertificateRefs field.
func (b *GatewayTLSConfigApplyConfiguration) WithCertificateRefs(values ...*SecretObjectReferenceApplyConfiguration) *GatewayTLSConfigApplyConfiguration {
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithCertificateRefs")
		}
		b.CertificateRefs = append(b.CertificateRefs, *values[i])
	}
	return b
}

// WithFrontendValidation sets the FrontendValidation field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the FrontendValidation field is set to the value of the last call.
func (b *GatewayTLSConfigApplyConfiguration) WithFrontendValidation(value *FrontendTLSValidationApplyConfiguration) *GatewayTLSConfigApplyConfiguration {
	b.FrontendValidation = value
	return b
}

// WithOptions puts the entries into the Options field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Options field,
// overwriting an existing map entries in Options field with the same key.
func (b *GatewayTLSConfigApplyConfiguration) WithOptions(entries map[v1.AnnotationKey]v1.AnnotationValue) *GatewayTLSConfigApplyConfiguration {
	if b.Options == nil && len(entries) > 0 {
		b.Options = make(map[v1.AnnotationKey]v1.AnnotationValue, len(entries))
	}
	for k, v := range entries {
		b.Options[k] = v
	}
	return b
}
