/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1alpha2

import (
	apisv1 "sigs.k8s.io/gateway-api/apis/applyconfiguration/apis/v1"
	v1 "sigs.k8s.io/gateway-api/apis/v1"
)

// UDPRouteRuleApplyConfiguration represents a declarative configuration of the UDPRouteRule type for use
// with apply.
type UDPRouteRuleApplyConfiguration struct {
	Name        *v1.SectionName                       `json:"name,omitempty"`
	BackendRefs []apisv1.BackendRefApplyConfiguration `json:"backendRefs,omitempty"`
}

// UDPRouteRuleApplyConfiguration constructs a declarative configuration of the UDPRouteRule type for use with
// apply.
func UDPRouteRule() *UDPRouteRuleApplyConfiguration {
	return &UDPRouteRuleApplyConfiguration{}
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *UDPRouteRuleApplyConfiguration) WithName(value v1.SectionName) *UDPRouteRuleApplyConfiguration {
	b.Name = &value
	return b
}

// WithBackendRefs adds the given value to the BackendRefs field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the BackendRefs field.
func (b *UDPRouteRuleApplyConfiguration) WithBackendRefs(values ...*apisv1.BackendRefApplyConfiguration) *UDPRouteRuleApplyConfiguration {
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithBackendRefs")
		}
		b.BackendRefs = append(b.BackendRefs, *values[i])
	}
	return b
}
